
#20180225
import bpy,sys
bl_info = {
    "name": "IMDJS_MeshTools",
    "author": "imdjs",
    "version": (2019,"0307"),
    "blender": (2, 80, 0),
    "api": 279,
    "location":" View3D >> specials menu (W key)",
    "description": "tools for mesh modification",
    "warning": "",
    "category": "Mesh"}


    
    
#/////////////////////////////////////////
# from .draw import G;
from .mesh_tools import *
#/////////////////////////////////////////
class 卐圆化选点卐Operator(bpy.types.Operator):
    bl_idname = 'mesh.round_selected_points'
    bl_label = 语.L圆选点[0]
    bl_description = 语.L圆选点[1]
    bl_options = { 'UNDO'}#'REGISTER',
    
    bp显示:BoolProperty(default=True);
    #------------------------------
    ep是传播:EnumProperty( name=语.EP是传播[0], description=语.EP是传播[1],items=  [("0","spread",语.EP是传播[3],"NONE",0),("1", "separate spread",语.EP是传播[4],"NONE",1)  ],default="0");
    #------------------------------
    ep传播1条:EnumProperty( name=语.EP传播1条[0], description=语.EP传播1条[1],items=  [("-1","none","---","NONE",0),("0","first",语.EP传播1条[2],"NONE",1),("1", "second",语.EP传播1条[3],"NONE",2)  ],default="-1");#-1 不处理,0 传第一条,1传另一条
    # bp是渐变圆:BoolProperty(name='--',description='渐变圆',default=False,subtype='NONE',update=None);  
    bp是自动轴:BoolProperty(name=语.bp是自动轴[0],description=语.bp是自动轴[1],default=False);
    fp圆心偏移:FloatProperty(name='radian',description='adjust the radian ',default=0.0,min=-100.0,max=100.0,step=3,precision=2,subtype='NONE',unit='NONE',update=None);
    # ep轴限制类型:EnumProperty( name=语.L锁轴[0], description=语.L锁轴[1],items=  [("0","x","---","NONE",0),("1", "y","---.","NONE",1) ,("2", "z","---.","NONE",2) ],default="0");
                                                                 
    @classmethod
    def poll(cls, context):
        LG.oA = context.active_object
        return (LG.oA and LG.oA.type == 'MESH' and context.mode == 'EDIT_MESH');
    """"""
    def draw(self, context):
        uil界 = self.layout;
        uil界.label(text=语.L锁轴[0],text_ctxt='',translate=True,icon='NONE',icon_value=0);

        uil行=uil界.row(align=False).split(factor=0.4,align=False);
        # 列=uil行.column(align=False);
        uil行.props_enum(self,'ep是传播');

        uil行2=uil行.split(factor=0.5,align=False);
        uil行2.props_enum(self,'ep传播1条');
        if(self.ep传播1条!="-1"):
            uil行2.prop(self,"bp是自动轴",translate=True,icon='NONE',slider=False,toggle=False);  
    #==============================
    def invoke(self, context, event):
        self.fp圆心偏移=0.0;self.bp是反选序=False;
        self.ep是传播="0";#self.ep轴限制类型="AUTO";
        LG.oA=context.active_object;
        key=LG.oA.data.shape_keys;
        if( key ):
            if(LG.oA.active_shape_key.value!=1):
                LG.oA.active_shape_key.value=1;

            if(1< len(LG.oA.data.shape_keys.key_blocks)):
                if(LG.oA.data.shape_keys .use_relative==False):
                    LG.oA.data.shape_keys .use_relative=True;
                if(LG.oA.show_only_shape_key==True):
                    LG.oA.show_only_shape_key=False;

        # return self.execute(context);
        return context.window_manager.invoke_props_dialog(self,width=400,height=50);
        # else:
            # return {"FINISHED"};

    def execute(self,context):
        print("EXE==",);
        #----初始化--------------------------
        if (context.area.type == 'VIEW_3D'): 
            if(LG.oA.mode!="OBJECT"):
                bpy.ops.object.mode_set(mode="OBJECT");
            LG.scene=context.scene;
            if(G.dllMESHTL==None):
                G.dllMESHTL=dll载入dll(G,"dllMESHTL",dllpathMESHB,dllpathMESH,None);LG.dllIMDJS=G.dllMESHTL;
                
            if(LG.cvpC==None or LG.scene==None):
                Δ初始化画MeshTool(True,True,True);
            LG.scene.ppMeshToolS.ip乚隔数=LG.scene.ppMeshToolS.ip乚隔数;
            LG.scene.ppMeshToolS.ip几轴=LG.scene.ppMeshToolS.ip几轴;LG.scene.ppMeshToolS.ip每节曲段数=LG.scene.ppMeshToolS.ip每节曲段数;LG.scene.ppMeshToolS.bp锁轴=LG.scene.ppMeshToolS.bp锁轴;LG.scene.ppMeshToolS.ep几条曲线=LG.scene.ppMeshToolS.ep几条曲线;LG.scene.ppMeshToolS.bp同步对选=LG.scene.ppMeshToolS.bp同步对选;#LG.scene.ppMeshToolS.ep轴限制类型=LG.scene.ppMeshToolS.ep轴限制类型;
            
            LG.b下LG.value=0;G.b下W__.value=0;G.b上W__.value=0;LG.b下RG.value=0;LG.b下中键G.value=0;#G.b下G__.value=0;G.b上G__.value=0;
            G.b按中乚L__.value=0;G.b退出__.value=0;#self.b换物体.value=0;
            
            #------------------------------
            LG.cvpOA=c_void_p(LG.oA.as_pointer()); LG.cvpC=c_void_p(context.as_pointer());
            I=G.dllMESHTL.iΔΔ画弧多条(LG.cvpC, LG.cvpOA,int(self.ep是传播),int(self.ep传播1条),self.bp是自动轴,LG.b中文界面);#Lf3输出弧_  ,self.bp是反选序,self.bp是渐变圆,c_float(self.fp圆心偏移)
            if(I<1):
                self.report({"ERROR"},"selected points can't make a circle!!");#"INFO" "ERROR" "DEBUG" "WARNING"
                return {"FINISHED"};
            G.dllMESHTL.Δ应用圆弧1块(LG.cvpC, LG.cvpOA,int(self.ep是传播),int(self.ep传播1条),self.bp是自动轴);#,self.bp是反选序,self.bp是渐变圆,c_float(self.fp圆心偏移)
            LG.oA.data.update();
            # bpy.ops.object.editmode_toggle();
            # return self.execute(context);
            #----增加乚------------------------------------------------
            """"""
            if(LG.scene.ppMeshToolS.bp不乚==False):
                if(self.bp显示):
                    if(G.乚MeshToolG==None):
                        print("add handle MeshTool+++",);
                        context.window_manager.modal_handler_add(self);
                else:
                    if(G.乚MeshToolG):
                        G.乚MeshToolG=None;#灬gl数据draw_mesher();
                        print("remove handle MeshTool---",);
                    return {"FINISHED"};
                
            #----------------------------------------
            Δ画3dMeshTool(True,True,True);
            # LG.oA.data.update();return {"FINISHED"};
            if(LG.scene.ppMeshToolS.bp不乚==False):
                return {'RUNNING_MODAL'};
            return {"FINISHED"};
                
        return {"FINISHED"};
        
    #----------------------------------------
    def modal(self, context, event):
        G.dllMESHTL.ΔΔ拖乚(LG.cvpC,True,self.bp是自动轴,int(self.ep传播1条),byref(LG.b下LG),byref(G.b下W__),byref(LG.b下中键G),byref(G.b按中乚L__),byref(G.b退出__));
        
        if(G.b退出__.value==1):
            print("!!QUIT round==",);
            self.report({"INFO"},"QUIT round");#"INFO" "ERROR" "DEBUG" "WARNING"
            if(LG.oA):
                LG.oA.data.update();
                bpy.ops.object.mode_set(mode="EDIT");
            bpy.ops.op.dll_mesh_tools();
            return {"FINISHED"};
            
        if(G.b按中乚L__.value==1):
            G.dllMESHTL.Δ应用圆弧1块(LG.cvpC, LG.cvpOA,int(self.ep是传播),int(self.ep传播1条),self.bp是自动轴);
            LG.oA.data.update();
            pass;
        elif(LG.b下中键G.value==1):            
            return {"PASS_THROUGH"};
        #----切换状态--------------------------
        elif(G.b下W__.value==1):
            return {'RUNNING_MODAL'};
        #----共用--------------------------
        # if(LG.b下LG.value==1):
            # if(G.b按中乚L__.value==1):
                # LG.oA.data.update();
            # return {"FINISHED"};
            # return {'RUNNING_MODAL'};

        return {'RUNNING_MODAL'};#这个只能有一种行为
        # return {"PASS_THROUGH"};#★这个让视窗不固定
    pass;
    
#/////////////////////////////////////////
class 卐曲线选点卐Operator(bpy.types.Operator):
    bl_idname = 'mesh.bezier_selected_points'
    bl_label = 语.L曲线选点[0]
    bl_description = 语.L曲线选点[1]
    bl_options = { 'UNDO'}#'REGISTER',
    
    bp显示:BoolProperty(default=True);
    
    ep是传播:EnumProperty( name=语.EP是传播[0], description=语.EP是传播[1],items=  [("0","spread",语.EP是传播[3],"NONE",0),("1", "separate spread",语.EP是传播[4],"NONE",1)  ],default="0");
    #------------------------------
    bp是自动轴:BoolProperty(name=语.bp是自动轴[0],description=语.bp是自动轴[1],default=False);
    ep传播1条:EnumProperty( name=语.EP传播1条[0], description=语.EP传播1条[1],items=  [("-1","all",语.EP传播1条[2],"NONE",0),("0","first",语.EP传播1条[3],"NONE",1),("1", "second",语.EP传播1条[4],"NONE",2)  ],default="-1");#-1 不处理,0 传第一条,1传另一条
    # ep轴限制类型:EnumProperty( name=语.L锁轴[0], description=语.L锁轴[1],items=  [("-1","none",语.L锁轴[2],"NONE",0),("0","x",语.L锁轴[3],"NONE",1),("1", "y",语.L锁轴[4],"NONE",2) ,("2", "z",语.L锁轴[5],"NONE",3)  ,("3", "auto",语.L锁轴[6],"NONE",4)],default="3");
                                                                 
    @classmethod
    def poll(cls, context):
        LG.oA = context.active_object;
        return (LG.oA and LG.oA.type == 'MESH' and context.mode == 'EDIT_MESH');
    
    def draw(self, context):
        uil界 = self.layout;
        uil界.label(text=语.L锁轴[0],text_ctxt='',translate=True,icon='NONE',icon_value=0);

        uil行=uil界.row(align=False).split(factor=0.4,align=False);
        # 列=uil行.column(align=False);
        uil行.props_enum(self,'ep是传播');

        uil行2=uil行.split(factor=0.5,align=False);
        uil行2.props_enum(self,'ep传播1条');
        if(self.ep传播1条!="-1"):
            uil行2.prop(self,"bp是自动轴",translate=True,icon='NONE',slider=False,toggle=False);

    #==============================
    def invoke(self, context, event):
        self.ep是传播="0";#self.ep轴限制类型="AUTO";
        LG.oA=context.active_object;
        key=LG.oA.data.shape_keys;
        if( key ):
            if(LG.oA.active_shape_key.value!=1):
                LG.oA.active_shape_key.value=1;

            if(1< len(LG.oA.data.shape_keys.key_blocks)):
                if(LG.oA.data.shape_keys .use_relative==False):
                    LG.oA.data.shape_keys .use_relative=True;
                if(LG.oA.show_only_shape_key==True):
                    LG.oA.show_only_shape_key=False;

        #----试玩版--------------------------
        if(G.dllMESHTL==None):
            G.dllMESHTL=dll载入dll(G,"dllMESHTL",dllpathMESHB,dllpathMESH,None);LG.dllIMDJS=G.dllMESHTL;
        # self.report({"ERROR"},"the curve function only availble in Pro version!!");#"INFO" "ERROR" "DEBUG" "WARNING"
        cp= c_char_p(b"https://gum.co/uuUht"); cp警告= c_char_p(b"the curve function only availble in Pro version!!"); 
        cp图片=os.path.abspath("%s/icons/4S.jpg" % path目录mesh_tools).encode('gb2312');
        # cp图片= c_char_p(b"https://gum.co/uuUht");
        G.dllMESHTL.Δ这是试玩版(cp,cp警告,cp图片);
        return {"FINISHED"};
        #------------------------------
        return context.window_manager.invoke_props_dialog(self,width=400,height=50);
        # else:
            # return {"FINISHED"};

    def execute(self,context):
        print("EXE==,LG.cvpC",LG.cvpC);
        #----初始化--------------------------
        if (context.area.type == 'VIEW_3D'): 
            if(LG.oA.mode!="OBJECT"):
                bpy.ops.object.mode_set(mode="OBJECT");
            LG.scene=context.scene;
            if(G.dllMESHTL==None):
                G.dllMESHTL=dll载入dll(G,"dllMESHTL",dllpathMESHB,dllpathMESH,None);LG.dllIMDJS=G.dllMESHTL;
            #------------------------------
            if(LG.cvpC==None or LG.scene==None):
                Δ初始化画MeshTool(True,True,True);
            LG.scene.ppMeshToolS.ip乚隔数=LG.scene.ppMeshToolS.ip乚隔数;
            LG.scene.ppMeshToolS.ip几轴=LG.scene.ppMeshToolS.ip几轴;LG.scene.ppMeshToolS.ip每节曲段数=LG.scene.ppMeshToolS.ip每节曲段数;LG.scene.ppMeshToolS.bp锁轴=LG.scene.ppMeshToolS.bp锁轴;LG.scene.ppMeshToolS.ep几条曲线=LG.scene.ppMeshToolS.ep几条曲线;LG.scene.ppMeshToolS.bp同步对选=LG.scene.ppMeshToolS.bp同步对选;#LG.scene.ppMeshToolS.ep轴限制类型=LG.scene.ppMeshToolS.ep轴限制类型;
            
            LG.b下LG.value=0;G.b下W__.value=0;G.b上W__.value=0;LG.b下RG.value=0;LG.b下中键G.value=0;#G.b下G__.value=0;G.b上G__.value=0;
            G.b按中乚L__.value=0;G.b退出__.value=0;#self.b换物体.value=0;
            #------------------------------
            LG.cvpOA=c_void_p(LG.oA.as_pointer()); LG.cvpC=c_void_p(context.as_pointer());
            I=G.dllMESHTL.iΔΔ画曲线多条(LG.cvpC, LG.cvpOA,int(self.ep是传播),int(self.ep传播1条),self.bp是自动轴,LG.b中文界面);#Lf3输出弧_
            if(I<1):return {"FINISHED"};
            G.dllMESHTL.Δ应用曲线1块(LG.cvpC, LG.cvpOA,int(self.ep是传播),int(self.ep传播1条),self.bp是自动轴);
            LG.oA.data.update();
            # bpy.ops.object.editmode_toggle();
            # return self.execute(context);
            #----增加乚------------------------------------------------
            """"""
            if(LG.scene.ppMeshToolS.bp不乚==False):
                if(self.bp显示):
                    if(LG.乚3dG==None):
                        print("modal_handler_add MeshTool+++",);
                        context.window_manager.modal_handler_add(self);
                else:
                    return {"FINISHED"};
            #----------------------------------------
            Δ画3dMeshTool(True,True,True);
            if(LG.scene.ppMeshToolS.bp不乚==False):
                return {'RUNNING_MODAL'};
            return {"FINISHED"};
            
        return {"FINISHED"};
        
    #----------------------------------------
    def modal(self, context, event):
        # return {"FINISHED"};
        G.dllMESHTL.ΔΔ拖乚(LG.cvpC,True,self.bp是自动轴,int(self.ep传播1条),byref(LG.b下LG),byref(G.b下W__),byref(LG.b下中键G),byref(G.b按中乚L__),byref(G.b退出__));
        
        if(G.b退出__.value==1):
            print("!!QUIT curve==",);
            self.report({"INFO"},"QUIT curve");#"INFO" "ERROR" "DEBUG" "WARNING"
            if(LG.oA):
                LG.oA.data.update();
                bpy.ops.object.mode_set(mode="EDIT");
            bpy.ops.op.dll_mesh_tools();
            return {"FINISHED"};
            
        if(G.b按中乚L__.value==1):
            G.dllMESHTL.Δ应用曲线1块(LG.cvpC, LG.cvpOA,int(self.ep是传播),int(self.ep传播1条),self.bp是自动轴);
            LG.oA.data.update();
            pass;
        elif(LG.b下中键G.value==1):            
            return {"PASS_THROUGH"};
        #----切换状态--------------------------
        elif(G.b下W__.value==1):
            return {'RUNNING_MODAL'};
        #----共用--------------------------
        # if(LG.b下LG.value==1):
            # if(G.b按中乚L__.value==1):
                # LG.oA.data.update();
            # return {"FINISHED"};
            # return {'RUNNING_MODAL'};

        return {'RUNNING_MODAL'};#这个只能有一种行为
        # return {"PASS_THROUGH"};#★这个让视窗不固定
    pass;
#//////////////////////////////////////////
class 卐桥焊接卐Operator(bpy.types.Operator):
    bl_idname = "op.mesh_tools_bridge_weld";
    bl_label = 语.L桥焊接[0];
    bl_options = {"REGISTER", "UNDO"};
    
    bp是焊接:BoolProperty(name=语.L桥焊接[0],description=语.L桥焊接[1],default=True,subtype='NONE',update=None);
    bp是按序焊接:BoolProperty(name=语.L桥焊接顺序[0],description=语.L桥焊接顺序[1],default=False,subtype='NONE',update=None);
    bp是反序:BoolProperty(name=语.L桥焊接反序[0],description=语.L桥焊接反序[1],default=False,subtype='NONE',update=None);
    bp是反方向:BoolProperty(name='opposite',description='reverse the second one of order',default=False,subtype='NONE',update=None);    
    ip左中右:IntProperty(name='LMR',description='weld points to the left or middle or right',default=1,min=0,max=2,step=1,subtype='NONE',update=None);

    
    @classmethod
    def poll(cls, context):
        LG.oA=context.active_object;
        if(LG.oA):
            return LG.oA.mode=="EDIT";
        return False;
    def draw(self, context):
        uil界 = self.layout;
        uil行=uil界.row(align=False);
        uil行.prop(data=self,property='bp是焊接',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=True,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        uil行.prop(data=self,property='bp是按序焊接',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=True,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);        
        uil行.prop(data=self,property='bp是反序',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=True,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);        
        uil行.prop(data=self,property='bp是反方向',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=True,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);        
        
        uil行=uil界.row(align=True);
        uil行.prop(data=self,property='ip左中右',text='LMR',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        
    def invoke(self,context,event):
        print("dllpathMESH==",dllpathMESH);
        return context.window_manager.invoke_props_dialog(self,width=400,height=50);
        return {"FINISHED"};

    def execute(self, context):
        if(G.dllMESHTL==None):
            G.dllMESHTL=dll载入dll(G,"dllMESHTL",dllpathMESHB,dllpathMESH,None);LG.dllIMDJS=G.dllMESHTL;
        LG.oA=context.active_object;
        cvpO=c_void_p(LG.oA.as_pointer());
        bpy.ops.object.editmode_toggle();
        #if(bpy.context.active_object.mode!="OBJECT"):bpy.ops.object.mode_set(mode="OBJECT");
        G.dllMESHTL.Δ桥焊接(cvpO,self.bp是按序焊接,self.bp是反序,self.bp是反方向,self.ip左中右);
        
        bpy.ops.object.editmode_toggle();
        if(self.bp是焊接):
            bpy.ops.mesh.remove_doubles(threshold=0.001, use_unselected=False);
        #G.dllMESHTL=dll卸载dll(G,"dllMESHTL");
        return {"FINISHED"};
    pass;
#//////////////////////////////////////////
class 卐卸载DLL卐Operator(bpy.types.Operator):
    bl_idname = "op.dll_mesh_tools";
    bl_label = "卸载dll";
    #bl_options = {"REGISTER", "UNDO"};

    @classmethod
    def poll(cls, context):
        return True; #(obj and obj.type == "MESH")
    def execute(self, context):
        if(G.dllMESHTL):
            G.dllMESHTL.卩泄漏();
            windll.kernel32.FreeLibrary.argtypes = [wintypes.HMODULE];#定义参数的类型
            windll.kernel32.FreeLibrary(G.dllMESHTL._handle);#释放dll
            LG.dllIMDJS=G.dllMESHTL=None;
            Δ画3dMeshTool(False);LG.灬cvp();#LG.cvpC  ■
            print("~ ~ ~ ~ ~ ~ ~DEL //////////////////////////////////////////////////////////",);
        return {"FINISHED"};
    pass;
#////////////////////////////////////////////
class MT_MT_MESH_TOOLS(bpy.types.Menu):
    bl_label = "MeshTools"
    def draw(self, context):
        uil界 = self.layout;
        uil界.operator(卐圆化选点卐Operator.bl_idname, text="raidian",icon="SPHERECURVE");
        uil界.operator(卐桥焊接卐Operator.bl_idname, text="bridge weld",icon="FULLSCREEN_EXIT");
        uil界.operator(卐对齐选线卐Operator.bl_idname,text="align selected",icon="COLLAPSEMENU");
        uil界.operator(卐矩形化选点卐Operator.bl_idname,text="rectangular",icon="MESH_PLANE");
        uil界.operator(卐轴到所选卐Operator.bl_idname,text="axis to select", icon="ORIENTATION_GLOBAL");
        uil界.separator();
        uil界.operator(卐转MESH到CURVE卐Operator.bl_idname,text="turn mesh to curve or turn curve to mesh", icon="OUTLINER_OB_CURVE");
        uil界.operator(卐curve平均化距离卐Operator.bl_idname,text="space the selected points", icon="IPO_CONSTANT");        
        uil界.separator();
        uil界.operator(卐选择相似_相似uvCURVE卐Operator.bl_idname,text="select faces have similar uv",icon="RESTRICT_SELECT_OFF");
    pass;
    
def Δmenu_mesh_tools(self, context):
    self.layout.menu("MT_MT_MESH_TOOLS",translate=True,icon="EDITMODE_HLT")
    self.layout.separator();
    
#//////////////////////////////////////////
class PT_PT_meshcurve(bpy.types.Panel):
    bl_label ="IMDJS_MeshTools (1.0)"
    # bl_label ="IMDJS_MeshTools Pro (1.0)"
    bl_space_type = 'VIEW_3D'#    IMAGE_EDITOR
    bl_region_type = 'UI' # TOOL_PROPS,UI,TOOLS
    bl_category = 'Tool'
    
    def draw(self, context):
        uil界 = self.layout;ppMeshToolS=context.scene.ppMeshToolS;
        uil界.label(text='----raidian--------------------------',text_ctxt='',translate=True,icon='NONE',icon_value=0);
        uil行=uil界.row(align=False);
        uil行.operator(卐圆化选点卐Operator.bl_idname, translate=True,icon="SPHERECURVE");
        uil行.operator(卐曲线选点卐Operator.bl_idname,translate=True,icon="CURVE_BEZCURVE");
        
        uil行=uil界.row(align=True);
        uil行.prop(ppMeshToolS,'ip每节曲段数',translate=True,icon='NONE',slider=False,toggle=False);
        uil行.prop(ppMeshToolS,'ip乚隔数',translate=True,icon='NONE',slider=False,toggle=False);
        
        # uil界.prop(ppMeshToolS,'bp不乚',translate=True,icon='NONE',slider=False,toggle=False);
        uil界.label(text='------------------------------',text_ctxt='',translate=True,icon='NONE',icon_value=0);
        
        uil行=uil界.row(align=False);
        uil行.operator(卐桥焊接卐Operator.bl_idname, text="bridge weld",icon="FULLSCREEN_EXIT");
        uil行.operator(卐对齐选线卐Operator.bl_idname,text="align selected",icon="COLLAPSEMENU");
        
        uil行=uil界.row(align=False);
        uil行.operator(卐矩形化选点卐Operator.bl_idname,text="rectangular",icon="MESH_PLANE");
        uil行.operator(卐轴到所选卐Operator.bl_idname,text="axis to select", icon="ORIENTATION_GLOBAL");
        
        uil界.separator();
        uil行=uil界.row(align=False);
        uil行.operator(卐转MESH到CURVE卐Operator.bl_idname,text="turn mesh to curve or turn curve to mesh", icon="OUTLINER_OB_CURVE");
        uil行.operator(卐curve平均化距离卐Operator.bl_idname,text="space the selected curve points", icon="IPO_CONSTANT");     
        
        uil界.separator();
        uil行=uil界.row(align=False);
        uil行.operator(卐选择相似_相似uvCURVE卐Operator.bl_idname,text="select faces have similar uv",icon="RESTRICT_SELECT_OFF");
        uil行.operator(卐关于我mesh_tools卐Operator.bl_idname,translate=True, icon = "QUESTION");
        
        uil行=uil界.row(align=False);
        uil行.operator(卐卸载DLL卐Operator.bl_idname, text="only for debug!",icon="CANCEL");
    pass;
    
def ΔUPDATEdr(self,context):
    if(G.b已经生成__.value):
        print("ΔUPDATEdr==",);
        if(LG.b停止更新G==False):
            LG.b停止更新G=True;
            G.dllDRMESH.iΔ重构曲线(LG.cvpC,c_void_p(LG.oA.as_pointer()),True);
            G.dllDRMESH.Δ最终成面ξ(LG.cvpC,c_void_p(LG.oA.as_pointer()),True,byref(G.ci线点数0G),byref(G.ci线点数1G),byref(G.ci线点数2G) \
                                                                    ,byref(LG.ci点数G),byref(LG.ci边数G),byref(LG.ci面数G),byref(LG.ci环数G));
            十点线面卩(LG.oA.data,LG.ci点数G.value,LG.ci边数G.value,LG.ci面数G.value,LG.ci环数G.value);
            G.dllDRMESH.重属性网(c_void_p(LG.oA.data.as_pointer()),True,False,False);
            LG.oA.data.update();

            LG.b停止更新G=False;
            
def ΔUPDATEcurve(self,context):
    if(G.b已经生成__.value):
        print("ΔUPDATEdr==",);
        if(LG.b停止更新G==False):
            LG.b停止更新G=True;
            
        LG.b停止更新G=False;
        
class 卐MeshTool卐PropertyGroupScene(bpy.types.PropertyGroup):
    name:bpy.props.StringProperty();
    ip每节曲段数:IntProperty(name=语.L每节曲段数[0],description=语.L每节曲段数[1],default=5,min=3,max=50,update=ΔUPDATEcurve);
    # ip几个截面:IntProperty(name=语.几个截面,description=语.几个截面,default=20,min=3,max=50,update=ΔUPDATEdr);
    ip乚隔数:IntProperty(name=语.L乚数[0],description=语.L乚数[1],default=2,min=1,max=30);
    ip几轴:IntProperty(name=语.L几轴[0],description=语.L几轴[1],default=3,min=2,max=3);
    bp锁轴:BoolProperty(name=语.L锁轴[0],description=语.L锁轴[1],default=True);#画第二个面时锁定平面
    ep几条曲线:EnumProperty( name=语.模式, description=语.模式,items=  [("1","1 curve","---","NONE",0),("2", "2 curve","---.","NONE",1)  ,("3", "3 curve","---.","NONE",2) ,("4", "4 curve","---.","NONE",3)],default="1");
    # ep轴限制类型:EnumProperty( name=语.L锁轴[0], description=语.L锁轴[1],items=  [("NONE","none","---","NONE",0),("X","x","---","NONE",1),("Y", "y","---.","NONE",2) ,("Z", "z","---.","NONE",3)  ,("AUTO", "auto","---.","NONE",4)  ],default="NONE");
    bp同步对选:BoolProperty(name=语.L同步对选[0],description=语.L同步对选[1],default=True);
    #----debug--------------------------
    bp不乚:BoolProperty(name="不乚",description="",default=False);
    pass;
    
L类=(卐圆化选点卐Operator,卐曲线选点卐Operator,卐桥焊接卐Operator,卐卸载DLL卐Operator,卐MeshTool卐PropertyGroupScene,卐画mesh_tool卐Operator,MT_MT_MESH_TOOLS,PT_PT_meshcurve);
L类2=(卐转MESH到CURVE卐Operator,卐curve平均化距离卐Operator,卐对齐选线卐Operator,卐选择相似_相似uvCURVE卐Operator,卐矩形化选点卐Operator,卐轴到所选卐Operator,卐关于我mesh_tools卐Operator);

#//////////////////////////////////////////
def register():
    注册类([L类,L类2]);
    bpy.types.Scene.ppMeshToolS=PointerProperty(type=卐MeshTool卐PropertyGroupScene);
    
    bpy.types.VIEW3D_MT_edit_mesh_context_menu.prepend(Δmenu_mesh_tools);
    # bpy.types.TOPBAR_MT_edit_curve_add.prepend(Δmenu_mesh_tools);
    bpy.types.VIEW3D_MT_edit_curve_context_menu.prepend(Δmenu_mesh_tools);    

def unregister():
    bpy.types.VIEW3D_MT_edit_mesh_context_menu.remove(Δmenu_mesh_tools);
    # bpy.types.TOPBAR_MT_edit_curve_add.remove(Δmenu_mesh_tools);    
    bpy.types.VIEW3D_MT_edit_curve_context_menu.remove(Δmenu_mesh_tools);      
    bpy.ops.op.dll_mesh_tools("INVOKE_DEFAULT");#print("文件夹此mesh_tools==",文件夹此mesh_tools);
    # print("sys.modules==",sys.modules.keys());
    删除模块(Ls模块名=[文件夹此mesh_tools+".mesh_tools",文件夹此mesh_tools+".LANG",文件夹此mesh_tools+".global_var",文件夹此mesh_tools+".draw",文件夹此mesh_tools]+Ls模块selfG+Ls模块G);
    
    del bpy.types.Scene.ppMeshToolS;
    注销类([L类,L类2]);
         
    print("unregister~~~",);

if __name__ == "__main__":
    register()


    
    
    
    
    
    
    
    