
import bpy,sys,os,imp,random
import bgl,gpu,blf;
# from gpu_extras.batch import batch_for_shader
shader = gpu.shader.from_builtin('2D_UNIFORM_COLOR');
from gpu.types import(GPUBatch,GPUIndexBuf,GPUVertBuf,);
#----------------------------------------
from bpy.props import BoolProperty;
from mathutils import Matrix,Vector,Euler
from ctypes import*
#from bpy_extras import object_utils
from bpy_extras import view3d_utils
#import bmesh
from math import*

path目录mesh_tools = os.path.dirname(__file__); #本py文件所在目录
文件夹此mesh_tools=os.path.basename(path目录mesh_tools);      #IMDJS_mesh_tools

if("IMDJS_mesh_tools.global_var" in sys.modules):
    G = sys.modules["IMDJS_mesh_tools.global_var"];
else:
    try:
        import IMDJS_mesh_tools.global_var as G;
    except:
        print("!!!ERROR import global_var",);

if("PYLIB.global_var_LIB" in sys.modules):
    LG = sys.modules["PYLIB.global_var_LIB"];
else:
    try:
        exec("import "+文件夹此mesh_tools+".PYLIB.global_var_LIB as LG");
        # import IMDJS_mesh_tools.PYLIB.global_var_LIB as LG;  
    except:
        import PYLIB.global_var_LIB as LG;  
    
try:
    from PYLIB.PYLIB_main import *
except:    
    from .PYLIB.PYLIB_main import*
#========================================
if(文件夹此mesh_tools+".LANG" in sys.modules):
    语=sys.modules[文件夹此mesh_tools+".LANG"];
else:
    exec("import "+文件夹此mesh_tools+".LANG as 语");#√
    
# try:
    # from .PYLIB.PYLIB_draw import *
# except:    
     # from PYLIB.PYLIB_draw import*

# from .PYLIB_print import PTL亖亖,PTLfn亖亖;
#from .PYLIB_math import f3十f3_ ;#Lcf3巜Lf3,Lf3巜Lcf3,
def f3十f3_(f3一,  f3二):   f3二[0]=f3一[0]+f3二[0];f3二[1]=f3一[1]+f3二[1];f3二[2]=f3一[2]+f3二[2];
#/////////////////////////////////////////
def Δ初始化画MeshTool(b画面=True,b画db=True,b画点厶=True,b画曲线=True,b画圆=True,b画字=True):
    if(G.dllMESHTL ==None):
        G.dllMESHTL=dll载入dll(G,"dllMESHTL",dllpath1,dllpath2,None);LG.dllIMDJS=G.dllMESHTL;
    G.dllMESHTL.定义曲线画数(byref(LG.ciSize丅G),byref(LG.ciSize一一G),byref(LG.ciSize乛G),byref(LG.ciSize点厶G),byref(LG.ciSize厶囗G),byref(LG.ciSize数G),byref(LG.ciSize字G));
    print("<<<INIT  LG.iSizeG DR0==",LG.ciSize乛G.value,LG.ciSize一一G.value,LG.ciSize丅G.value,G.dllMESHTL,LG.CL段序L4f2乛画G,LG.CL段序L2f2一一画G);
    #----初始化--------------------------
    if(b画曲线 and LG.CL段序L4f2乛画G==None or LG.CL段序L2f2一一画G==None or G.CL段序L4f2乛画1G==None):
        LG.CL段序L4f2乛画G=(c_float*2*4*LG.ciSize乛G.value)();
        G.CL段序L4f2乛画1G=(c_float*2*4*LG.ciSize乛G.value)();
        G.CL段序L4f2乛画2G=(c_float*2*4*LG.ciSize乛G.value)();
        G.CL段序L4f2乛画3G=(c_float*2*4*LG.ciSize乛G.value)();
        LG.CL段序L2f2一一画G=(c_float*2*2*LG.ciSize一一G.value)();
        LL=[(0,0)]*LG.ciSize丅G.value;
        LG.CLf2丅画G=(c_float*2*LG.ciSize丅G.value)(*LL);#左边是位置,右边是颜色
        G.CLf2丅画1G=(c_float*2*LG.ciSize丅G.value)(*LL);
        G.CLf2丅画2G=(c_float*2*LG.ciSize丅G.value)(*LL);
        G.CLf2丅画3G=(c_float*2*LG.ciSize丅G.value)(*LL);
        print("---- init==",);
        if(b画面 and LG.CL面序Lnf4厶囗画G==None):
            LG.CL面序Lnf4厶囗画G=(c_float*4*5*LG.ciSize厶囗G.value)();
            # LG.CL段序L2f2一一序卅画G=(c_float*2*2*300)();
        if(b画点厶 and LG.CLL4f4点厶画G==None):
            LG.CLL4f4点厶画G=(c_float*4*4*LG.ciSize点厶G.value)();   
    #----DB--------------------------
    if(b画db and (LG.CLL2f4丅画dbG==None or LG.CL段序L3f4一一画dbG==None or LG.CL段序L5f4乛画dbG==None)):        
        G.dllMESHTL.Δ定义画数db(byref(LG.ciSize丅dbG),byref(LG.ciSize一一dbG),byref(LG.ciSize乛dbG));
        LG.CLL2f4丅画dbG=(c_float*4*2*LG.ciSize丅dbG.value)();
        LG.CL段序L3f4一一画dbG=(c_float*4*3*LG.ciSize一一dbG.value)();
        LG.CL段序L5f4乛画dbG=(c_float*4*5*LG.ciSize乛dbG.value)();  
    #------------------------------
    if(b画圆):
        G.dllMESHTL.Δ定义画圆数(byref(LG.圆.ciSize丅G),byref(LG.圆.ciSize一一G),byref(LG.圆.ciSize点厶G));
        LL=[(0,0)]*LG.圆.ciSize丅G.value;
        LG.圆.CLf2丅画G=(c_float*2*LG.圆.ciSize丅G.value)(*LL);
        LG.圆.CL段序L2f2一一画G=(c_float*2*2*LG.圆.ciSize一一G.value)();
        LG.圆.CLL4f4点厶画G=(c_float*4*4*LG.圆.ciSize点厶G.value)();   
        LG.圆1.CLf2丅画G=(c_float*2*LG.圆.ciSize丅G.value)(*LL);
        LG.圆1.CL段序L2f2一一画G=(c_float*2*2*LG.圆.ciSize一一G.value)();
        LG.圆1.CLL4f4点厶画G=(c_float*4*4*LG.圆.ciSize点厶G.value)();
        LG.圆2.CLf2丅画G=(c_float*2*LG.圆.ciSize丅G.value)(*LL);
        LG.圆2.CL段序L2f2一一画G=(c_float*2*2*LG.圆.ciSize一一G.value)();
        LG.圆2.CLL4f4点厶画G=(c_float*4*4*LG.圆.ciSize点厶G.value)();
        LG.圆3.CLf2丅画G=(c_float*2*LG.圆.ciSize丅G.value)(*LL);
        LG.圆3.CL段序L2f2一一画G=(c_float*2*2*LG.圆.ciSize一一G.value)();
        LG.圆3.CLL4f4点厶画G=(c_float*4*4*LG.圆.ciSize点厶G.value)();
        #----●●下面可能会crash--------------------------
        if(b画字 and LG.CLL2f4丅数画G==None):
            LLL=[((0,0,0,1),(0,0,0,1))]*LG.ciSize数G.value;print("LG.iSize数G==",LG.ciSize数G.value,*LLL);
            LG.CLL2f4丅数画G=(c_float*4*2*LG.ciSize数G.value)(*LLL);
            LLL=[((0,0,0,1),(0,0,0,1))]*LG.ciSize字G.value;
            LG.CLL2f4丅字画G=(c_float*4*2*LG.ciSize字G.value)(*LLL);
            LG.CLs64字G=(c_char*64*LG.ciSize字G.value)();
            # LG.b是2dG=True;
    # if(LG.cvpC==None or LG.cvpOA==None ):
        # LG.C=bpy.context;
        # LG.cvpC=c_void_p(LG.C.as_pointer());#LG.cvpOA=c_void_p(LG.C.active_object.as_pointer()); 
    # if(G.dllMESHTL):
        # G.dllMESHTL.b凷rv3d(c_void_p(bpy.context.as_pointer()));

    print(">>INIT LG.iSizeG DR1==");
    

def 灬gl数据MeshTool():
    print("<<<CLEAR data dr 0==",);
    #----CF----------------------------------------------
    LG.CLf2丅画G=None;G.CLf2丅画1G=None;G.CLf2丅画1G=None;G.CLf2丅画2G=None;
    LG.CL段序L2f2一一序卅画G=None;LG.CL段序L2f2一一画G=None;

    LG.CL段序L4f2乛画G=None;G.CL段序L4f2乛画1G=None;G.CL段序L4f2乛画2G=None;G.CL段序L4f2乛画3G=None;
    # LG.CL面序L4f4厶画G=None;LG.CL面序L5f4囗画G=None;
    LG.CL面序Lnf4厶囗画G=None;
    LG.CLL2f4丅数画G=None;LG.CLL2f4丅字画G=None;LG.CLs64字G=None;LG.b画数G=False;LG.b画字G=False;
    #----DB--------------------------
    LG.CLL2f4丅画dbG=None;LG.CL段序L3f4一一画dbG=None;LG.CL段序L5f4乛画dbG=None;
    
    LG.LLf2·2=[];G.LLf2·21=[];G.LLf2·22=[];G.LLf2·23=[];
    LG.LLf2·2一一=[];LG.f2丅画=None;
    LG.LLf6·2=[];G.LLf6·21=[];G.LLf6·22=[];G.LLf6·23=[];
    LG.艹pre丅=0;G.艹pre丅1=0;G.艹pre丅2=0;G.艹pre丅3=0;
    LG.艹pre乛=0;G.艹pre乛1=0;G.艹pre乛2=0;G.艹pre乛3=0;
    #----〇--------------------------
    LG.圆.〇();LG.圆1.〇();LG.圆2.〇();LG.圆3.〇();
    #----丄-------------------------------------------------
    # LG.CL条序L2f2丄画G=None;
    LG.b停止更新G=False;
    print(">>CLEAR data dr 1==",);
    
    
#////画线///////////////////////////////////////
def Δ画线3dMeshTool(self,context):#L2v丅
    # if(G.dllMESHTL.iΔ打印次数()):
        # print("START draw mesh tool==",G.dllMESHTL.iΔ打印次数());
    bgl.glEnable(bgl.GL_BLEND);
    # rgba=[1,1,1,1];
    # bgl.glBegin(bgl.GL_LINES);#●●ΧGL_LINES 独立的线段   GL_POINT   GL_LINE_STIPPLE  GL_LINE_STRIP GL_LINE_LOOP 依次1个点连1个点
    rgba=LG.蓝; 
    bgl.glPointSize(6);
    bgl.glLineWidth(1);
    #print("DRAW　Lv丅实物画G==",LG.Cf3实物画G);
    #----cf----------------------------------------------
    G.dllMESHTL.下上曲线画(byref(LG.艹丅画G),LG.CLf2丅画G,LG.col丅G \
                ,byref(G.艹丅画1G),G.CLf2丅画1G,G.col丅1G \
                ,byref(G.艹丅画2G),G.CLf2丅画2G,G.col丅2G  \
                ,byref(G.艹丅画3G),G.CLf2丅画3G,G.col丅3G  \
                ,byref(LG.艹一一画G),LG.CL段序L2f2一一画G ,LG.col一一G \
                ,byref(LG.艹乛画G) ,LG.CL段序L4f2乛画G,LG.col乛G  \
                ,byref(G.艹乛画1G),G.CL段序L4f2乛画1G,G.col乛1G  \
                ,byref(G.艹乛画2G),G.CL段序L4f2乛画2G,G.col乛2G  \
                ,byref(G.艹乛画3G),G.CL段序L4f2乛画3G,G.col乛3G  \
                ,byref(LG.艹厶囗画G),LG.CL面序Lnf4厶囗画G \
                );
                
    # PTL亖亖(LG.CL段序L2f2一一画G[0]);PTL亖亖(LG.CL段序L2f2一一画G[1]);    #====点====================================
    ΔΔ画n点(LG);
    #----1--------------------------
    ΔΔ画n点1(G);
    """"""
    #----2--------------------------
    ΔΔ画n点2(G);
    #----3--------------------------
    ΔΔ画n点3(G);
    #---- 一一 --------------------------
    ΔΔ画n一一(LG);
    #----cf箭头----------------------------------------------
    ΔΔ画n乛(LG);#print("G.艹乛画1G==",G.艹乛画1G.value,);
    #---- 乛1 --------------------------
    ΔΔ画n乛1(G);
    #---- 乛2 --------------------------
    ΔΔ画n乛2(G);
    #---- 乛3 --------------------------
    ΔΔ画n乛3(G);
    
    # if(G.dllMESHTL.iΔ打印次数()):
        # print("END draw mesh tool==",G.dllMESHTL.iΔ打印次数());
    # return;
    #----厶囗--------------------------
    for i in range(LG.艹厶囗画G.value):
        LG.CL5f4=LG.CL面序Lnf4厶囗画G[i];
        if(LG.CL5f4[4][0]==0 and LG.CL5f4[4][1]==0 ):
            Δ画厶(LG.CL5f4);
        else:
            Δ画囗(LG.CL5f4);
        # print("LG.CL5f4==",*LG.CL5f4[0],*LG.CL5f4[1],*LG.CL5f4[2],*LG.CL5f4[3],*LG.CL5f4[4]);  
    #====〇====================================
    if(LG.b画圆G):
        G.dllMESHTL.下上圆画(byref(LG.圆.艹丅画G),LG.圆.CLf2丅画G,LG.圆.col丅G \
                                                    ,byref(LG.圆.艹一一画G) ,LG.圆.CL段序L2f2一一画G,LG.圆.col一一G  \
                                                    
                                                    ,byref(LG.圆1.艹丅画G),LG.圆1.CLf2丅画G,LG.圆1.col丅G \
                                                    ,byref(LG.圆1.艹一一画G) ,LG.圆1.CL段序L2f2一一画G,LG.圆1.col一一G  \
                                                    
                                                    ,byref(LG.圆2.艹丅画G),LG.圆2.CLf2丅画G,LG.圆2.col丅G \
                                                    ,byref(LG.圆2.艹一一画G) ,LG.圆2.CL段序L2f2一一画G,LG.圆2.col一一G  \
                                                    
                                                    ,byref(LG.圆3.艹丅画G),LG.圆3.CLf2丅画G,LG.圆3.col丅G \
                                                    ,byref(LG.圆3.艹一一画G) ,LG.圆3.CL段序L2f2一一画G,LG.圆3.col一一G  \
                                                    );#print("LG.艹点厶画G==",LG.艹点厶画G.value,LG.CLL4f4点厶画G);
        ΔΔ画n点(LG.圆);ΔΔ画n点(LG.圆1);ΔΔ画n点(LG.圆2);ΔΔ画n点(LG.圆3);
        ΔΔ画n一一(LG.圆);ΔΔ画n一一(LG.圆1);ΔΔ画n一一(LG.圆2);ΔΔ画n一一(LG.圆3);

    #====db====================================
    if(LG.b画dbG):
        G.dllMESHTL.下上丅画db(byref(LG.艹丅画dbG),LG.CLL2f4丅画dbG);     
        for i in range(LG.艹丅画dbG.value):
            LG.CL2f4=LG.CLL2f4丅画dbG[i];
            if(LG.CL2f4[0][0]==0 and LG.CL2f4[0][1]==0):
                continue;
            Δ画1点(LG.CL2f4);
        #---- 一一 --------------------------
        G.dllMESHTL.下上一一画db(byref(LG.艹一一画dbG),LG.CL段序L3f4一一画dbG);     
        for i in range(LG.艹一一画dbG.value):
            LG.CL3f4=LG.CL段序L3f4一一画dbG[i];
            if(LG.CL3f4[0][0]==0 and LG.CL3f4[1][1]==0):
                continue;
            Δ画1线(LG.CL3f4);
        #---- 乛 --------------------------
        G.dllMESHTL.下上乛画db(byref(LG.艹乛画dbG),LG.CL段序L5f4乛画dbG);     #print("LG.艹乛画dbG.value==",LG.艹乛画dbG.value,LG.ciSize乛dbG.value);
        for i in range(LG.艹乛画dbG.value):
            LG.CL5f4=LG.CL段序L5f4乛画dbG[i];#print("==",*LG.CL5f4[0]);
            if(LG.CL5f4[0][0]==0 and LG.CL5f4[1][1]==0):
                continue;
            Δ画1乛(LG.CL5f4);#print("LG.CL5f4==",*LG.CL5f4);
    #====点厶====================================
    if(LG.b画点厶G):
        G.dllMESHTL.下上点厶画(byref(LG.艹点厶画G),LG.CLL4f4点厶画G);#print("LG.艹点厶画G==",LG.艹点厶画G.value,*LG.CLL4f4点厶画G[0][0]);#
        for i in range(LG.艹点厶画G.value):
            LG.CL4f4=LG.CLL4f4点厶画G[i];                       
            if(LG.CL4f4[0][0]==0 and LG.CL4f4[1][1]==0):
                continue;
            Δ画厶(LG.CL4f4);#print("LG.CL4f4==",*LG.CL4f4[0],*LG.CL4f4[1],*LG.CL4f4[2],*LG.CL4f4[3]); 
    #----画字------------------------------------------------------
    if(LG.b画字G):
        blf.size(0, 15, 75);
        LG.dllIMDJS.下上字画(byref(LG.艹字画G),LG.CLL2f4丅字画G,LG.CLs64字G,True);
        艹=LG.艹字画G.value;
        for i in range(艹):
            LG.CL2f4=LG.CLL2f4丅字画G[i];
            if(LG.CL2f4[0][0]==0 and LG.CL2f4[1][1]==0):
                continue;
            blf.color(0,*LG.CL2f4[1]);
            blf.position(0,LG.CL2f4[0][0], LG.CL2f4[0][1], 0);#(fontid, x, y, z)
            blf.draw(0, LG.CLs64字G[i].value);print("s64==",LG.CLs64字G[i].value,LG.CL2f4[0][0], LG.CL2f4[0][1]);
            
    bgl.glDisable(bgl.GL_BLEND);


#/////////////////////////////////////////
class 卐画mesh_tool卐Operator(bpy.types.Operator):
    bl_idname = "op.draw_mesh_tool"
    bl_label = "draw_mesh_tool"
    bl_description = "draw_mesh_tool"
    
    bp显示:BoolProperty(default=False);
    bp画数:BoolProperty(default=False);bp画字:BoolProperty(default=False);bp画点厶:BoolProperty(default=False);
    bp画db:BoolProperty(default=False);bp画圆:BoolProperty(default=False);
    #==============================================================
    def invoke(self, context, event):
        if(LG.area3dG==None):
            screen=context.screen;
            for area in screen.areas:
                if(area.type=="VIEW_3D"):
                    LG.area3dG=area;
                    area.tag_redraw();
                    # for space in area.sp
        LG.b画数G=self.bp画数;LG.b画字G=self.bp画字;LG.b画点厶G=self.bp画点厶;LG.b画dbG=self.bp画db;LG.b画圆G=self.bp画圆;
        #----增加乚----------------------------------------------------
        if(self.bp显示):
            if(G.dllMESHTL):
                if(G.dllMESHTL.b凷rv3d(c_void_p(context.as_pointer()))==False):
                    print("!!!no 3d windows==",);
                    return {"FINISHED"};
            else:
                self.report({"WARNING"},"G.dllMESHTL==None");#"INFO" "ERROR" "DEBUG" "WARNING"
                print("!!!!G.dllMESHTL==",G.dllMESHTL);return {"FINISHED"};
                
            if(LG.乚3dG==None):
                LG.乚3dG = bpy.types.SpaceView3D.draw_handler_add(Δ画线3dMeshTool,(self, context), 'WINDOW', 'POST_PIXEL');#POST_VIEW(无画),POST_PIXEL(画)
                print("add draw乚 mesh_tool+++",);
                

            if(LG.area3dG):
                LG.area3dG.tag_redraw();
        else:
            if(LG.乚3dG):
                if(G.dllMESHTL):   
                    G.dllMESHTL.〇画dr(-1,False);
                    Δ画线3dMeshTool(self,context);
                    G.dllMESHTL.〇画艹dr();
                if(LG.area3dG):
                    LG.area3dG.tag_redraw();
                self.bp显示=False;灬gl乚();灬gl数据MeshTool();LG.灬cvp();
                print("clear draw乚 mesh_tool ----",);
        return {"FINISHED"}; 

    #------------------------------
    # def __del__(self):
        # try:
            # if(LG.乚3dG):
                # self.bp显示=False;灬gl乚();灬gl数据MeshTool();
        # except:pass;        


#/////////////////////////////////////////
def Δ画3dMeshTool(bp显示,bp画db=True,bp画点厶=True,bp画圆=True,bp画数=False,bp画字=True):
    bpy.ops.op.draw_mesh_tool("INVOKE_DEFAULT",bp显示=bp显示,bp画db=bp画db,bp画点厶=bp画点厶,bp画圆=bp画圆,bp画数=bp画数,bp画字=bp画字);





#////end////end////end////end////end////end////end////end////








