
import os

from .draw import*;
        
path目录mesh_tools = os.path.dirname(__file__); #本py文件所在目录
文件夹此mesh_tools=os.path.basename(path目录mesh_tools);

dllpathMESHB="B:/mesh_tools64.dll"        
#dllpathMESHB=os.path.abspath("%s/mesh_tools32.dll" % path目录mesh_tools);
dllpathMESH=os.path.abspath("%s/mesh_tools64.dll" % path目录mesh_tools);

#--------------------------------------------------------------
class 卐转MESH到CURVE卐Operator(bpy.types.Operator):
    bl_idname = "turn.mesh_curve"
    bl_label = "MESH to CURVE "
    bl_options = {"REGISTER", "UNDO"}
    bl_description="turn mesh to curve or turn curve to mesh"
    ip分辨率:IntProperty(name="分辨率",description="曲线分辨率",default= 3,min=0, max=12,);
    bp结尾:BoolProperty(name="结尾",description="结尾",default= True ,);
    @classmethod
    def poll(cls, context):#决定是否激活
        if(context.active_object):
            return (context.active_object.type in ["MESH","CURVE"]);
        return False;
        
    def draw(self, context):
        if(context.active_object.type=="MESH"):
            row = self.layout.row();
            row.prop(self, "ip分辨率");
            row.prop(self, "bp结尾");

    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self,width=400,height=50)

    def execute(self, context):
        # bpy.ops.object.editmode_toggle();
        oA=context.active_object;
        if(oA.type=="MESH"):
            # bpy.ops.object.mode_set(mode="EDIT");
            bpy.ops.object.mode_set(mode="OBJECT");
            bpy.ops.object.convert(target="CURVE", keep_original=False);
            c2=context.active_object.data;
            #print(oA.name);
            c2.resolution_u=self.ip分辨率;
            Lsp=c2.splines;
            print(Lsp)
            for sp in Lsp:
                #sp.type="BEZIER"
                sp.type="NURBS"
                sp.resolution_u=self.ip分辨率;
                sp.use_endpoint_u=self.bp结尾;
                #for bz in sp.bezier_points:
                    #bz.handle_left_type="AUTO";
        elif(oA.type=="CURVE"):
            bpy.ops.object.mode_set(mode="OBJECT");
            bpy.ops.object.convert(target="MESH", keep_original=False);
        return {"FINISHED"}
    pass;
#--------------------------------------------------------------
class 卐curve平均化距离卐Operator(bpy.types.Operator):
    bl_idname = "op.space_curve"
    bl_label = "space_curve "
    bl_options = {"REGISTER", "UNDO"}
    bl_description="space the curve points "
    fpFac:FloatProperty(name='',description='',default=0.0,min=0.0,max=1.0,step=3,precision=2,subtype='EP传播',unit='EP传播',update=None);
    
    @classmethod
    def poll(cls, context):#决定是否激活
        if(context.active_object):
            return (context.active_object.type in ["CURVE"]);
        return False;
        
    def draw(self, context):
        row = self.layout.row();
        row.prop(self, "fpFac");

    def execute(self, context):
        if(G.dllMESHTL==None):
            G.dllMESHTL=dll载入dll(G,"dllMESHTL",dllpathMESHB,dllpathMESH,None);LG.dllIMDJS=G.dllMESHTL;
        if(LG.cvpC==None or LG.scene==None):
            Δ初始化画MeshTool(True,True,True);
        oA=context.active_object;
        cvpOA = c_void_p(oA.as_pointer());cvpC= c_void_p(context.as_pointer());
        bpy.ops.object.editmode_toggle();
        G.dllMESHTL.Δ平均化贝兹重定位(cvpC,cvpOA);
        bpy.ops.object.editmode_toggle();
        return {"FINISHED"}     
    pass;
#------------------------------------------------
def ΔUPDATE选择(self, context):
    if(self.bp旋转归零 and self.bp丄):
        self.bp丄=False;
    #elif(self.bp丄):
        #self.bp旋转归零=False;


 #///////////////////////////////////////////
class 卐对齐选线卐Operator(bpy.types.Operator):
    bl_idname = "bp.align_to_selected_line"
    bl_label = "align or straighten the selected points"
    bl_options = {"REGISTER", "UNDO"}

    bp选点自动对齐:BoolProperty(name="selected auto",description="选点自动对齐",default=False)
    bp拉直:BoolProperty(name="straighten",description="拉直",default=False)
    bp自动对齐:BoolProperty(name="auto",description="自动对齐",default=False)
    bp对齐到最后选点:BoolProperty(name="align to last select",description="对齐到最后选点",default=True)
    bpX:BoolProperty(name="X",description="对齐X",default=False)
    bpY:BoolProperty(name="Y",description="对齐Y",default=False)
    bpZ:BoolProperty(name="Z",description="对齐Z",default=False)
    bm=None;
    
    @classmethod
    def poll(cls, context):#决定是否激活
        o选=context.object
        if (o选!=None and (o选.type=="MESH" or o选.type=="CURVE")and (context.mode=="EDIT_MESH" or context.mode=="EDIT_CURVE" ) ):
            return True;
        return False;

    def draw(self, context):#第貮步
        layout = self.layout;
        #layout.prop(self, "bp旋转归零");
        layout.prop(self, "bp选点自动对齐");
        uil行=layout.row(align=True);
        uil行.prop(self, "bp拉直");
        uil行.prop(self, "bp自动对齐");
        layout.prop(self, "bp对齐到最后选点");
        uil行=layout.row(align=True);
        #if(not self.bp自动对齐):
        uil行.prop(self, "bpX");uil行.prop(self, "bpY");uil行.prop(self, "bpZ");

    def invoke(self, context, event):#召唤 第1步
        #oA=context.active_object;id=oA.data;self.bm = bmesh.from_edit_mesh(id);
        return context.window_manager.invoke_props_dialog(self,width=400,height=50);

    #                     ┃
    #                     ┃
    #       ○━━●━━○━━>
    #                     ┃
    #                     ┃

    def execute(self, context): #第三步
        oA=context.active_object;id=oA.data;
        #if(self.bm==None):
        self.bm = bmesh.from_edit_mesh(id);
        #print("self.bm==",self.bm);
        if(self.bm.select_history):
            bmve最后选=self.bm.select_history.active;
        else:
            bmve最后选=None;
        Lbme选 = [] ;
        #------------------------------------------------------------
        #print("bmesh",len(self.bm.edges));
        for bme in self.bm.edges: #This meshes bme sequence (read-only).Type : BMEdgeSeq
            if (bme.select):
                Lbme选.append(bme);

        bme随机边=Lbme选[0];bmv左=bme随机边.verts[0];bmv右=bme随机边.other_vert(bmv左);
        print("LR==",bmv左,bmv右);
        L序v选点丅=[];L序v选点丅.append(bmv左.co);L序v选点丅.append(bmv右.co);#[[bmv,v左],[bmv,v右]]
        #L序bmv选点=[];
        #L序点ξ=[];L序点ξ.append(bmv左.index);L序点ξ.append(bmv右.index);

        i边数2=i边数=len(Lbme选)+1;
        """
        for bme连选 in bmv左.link_edges:
            if(bme连选.select and bme连选 !=bme随机边 ):
                print("L==",bme连选);

        for bme连选 in bmv右.link_edges:
            if(bme连选.select and bme连选 !=bme随机边 ):
                print("R==",bme连选);
        """
        #----往左添加co---------------------------------------------------------------
        bme随机边右=bme随机边;#随机边会变化 所以要分左右
        bme随机边左=bme随机边;
        
        while(i边数>0):
            for bme连选 in bmv左.link_edges: #Edges connected to this vertex (read-only).
                                                                        #Type : BMElemSeq of BMVert
                if (bme连选.select and bme连选 !=bme随机边左): # 另1条选边
                    bmv下一点 = bme连选.other_vert(bmv左);print("L==",bmv左.index);
                    #bmv随机点的下1个点 <----o----o==o
                    #                                          bmv下一点   bmv左
                    L序v选点丅.insert(0,bmv下一点.co);#L序点ξ.insert(0,bmv下一点.index);
                    #L序bmv选点.insert(0,bmv下一点);
                    bmv左=bmv下一点;bme随机边左=bme连选;
                    break;
            i边数-=1;
        #----往右添加co---------------------------------------------------------------;
        while(i边数2>0):
            for bme连选 in bmv右.link_edges: #Edges connected to this vertex (read-only).
                                                                        #Type : BMElemSeq of BMVert
                if (bme连选.select and bme连选 !=bme随机边右): # 另1条选边
                    bmv下一点 = bme连选.other_vert(bmv右); print("R==",bmv右.index);
                    #bmv随机点的下1个点  o==o----o---->
                    #                                                bmv右  bmv下一点
                    L序v选点丅.append(bmv下一点.co);#L序点ξ.append(bmv下一点.index);
                    #L序bmv选点.append(bmv下一点);
                    bmv右=bmv下一点;bme随机边右=bme连选;
                    break;
            i边数2-=1;
        #----求最近选的v丅---------------------------------------------------------------
        if(self.bp对齐到最后选点 and bmve最后选!=None):
            if(hasattr(bmve最后选,"verts")):#线中点
                v最后选=(bmve最后选.verts[0].co+bmve最后选.verts[1].co)/2;
            else:
                v最后选=bmve最后选.co;
        else:
            v总和=Vector();
            for v选点丅_  in L序v选点丅:
                v总和+=v选点丅_;

            v最后选=v总和/len(L序v选点丅);

        #------------------------------------------------------------
        v头乛尾=L序v选点丅[-1]-L序v选点丅[0];
        f头尾长=v头乛尾.length;


        if(not self.bp选点自动对齐):
            #----拉直-------------------------------------------------
            if(self.bp拉直):
                v乛头=L序v选点丅[0];v乛尾=L序v选点丅[-1];
                i点数=len(L序v选点丅);i=0 ;
                for  v选点丅_ in (L序v选点丅):
                    if(i==0 or i==(i点数-1)):print("I==",i);i+=1;continue;#头尾不选
                    v乛头__此=v选点丅_-v乛头;
                    f夹角=v乛头__此.angle(v头乛尾);print("ANGLE==",degrees(f夹角));
                    f邻边长=v乛头__此.length*cos(f夹角);print("LEN==",f邻边长);
                    v此点丅=v头乛尾*(f邻边长/f头尾长)+v乛头;
                    #print("V==",v此点丅,v选点丅_);
                    v选点丅_.x=v此点丅.x;v选点丅_.y=v此点丅.y;v选点丅_.z=v此点丅.z;#必须这样二值才成功
                    i+=1;
            #----对齐------------------------------------------------
            else:
                if(self.bp自动对齐):
                    x=abs(v头乛尾.x); y=abs(v头乛尾.y); z=abs(v头乛尾.z);
                    if(x>y and x>z):
                        for v选点丅_  in L序v选点丅:
                            v选点丅_.y=v最后选.y;v选点丅_.z=v最后选.z;

                    elif(y>x and y>z):
                        for v选点丅_  in L序v选点丅:
                            v选点丅_.x=v最后选.x;v选点丅_.z=v最后选.z;

                    elif(z>x and z>y):
                        for v选点丅_  in L序v选点丅:
                            v选点丅_.y=v最后选.y;v选点丅_.x=v最后选.x;

                else:
                    for v选点丅_  in L序v选点丅:
                        if(self.bpX):
                            v选点丅_.x=v最后选.x;
                        if(self.bpY):
                            v选点丅_.y=v最后选.y;
                        if(self.bpZ):
                            v选点丅_.z=v最后选.z;

            #----选点自动对齐---------------------------------------------------------------
            #☐☐━━━━━━━━━━━━━━☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐┃☐☐☐●☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐┃☐☐┆☐\☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐┃☐☐│☐☐\☐☐☐☐☐●┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐┃☐┆☐☐☐☐\☐☐┄─☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐┃☐│☐☐☐☐☐●─☐☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐┃●☐☐☐☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
            #☐☐━━━━━━━━━━━━━━☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐

        else:
            Lbmv选=[bmv  for bmv in self.bm.verts  if (bmv.select)];
            v总和=Vector();
            v头乛尾=Lbmv选[-1].co-Lbmv选[0].co;
            if(not self.bp对齐到最后选点):
                for bmv  in Lbmv选:
                    v总和+=bmv.co;
                v最后选=v总和/len(Lbmv选);

            if(self.bp自动对齐):
                #----计算边界--------------------------------------------------------------
                x小=y小=z小=100000; x大=y大=z大=-100000;
                for bmv  in Lbmv选:
                    v点丅=bmv.co;
                    if(v点丅.x<x小):x小=v点丅.x;
                    if(v点丅.x>x大):x大=v点丅.x;
                    if(v点丅.y<y小):y小=v点丅.y;
                    if(v点丅.y>y大):y大=v点丅.y;
                    if(v点丅.z<x小):z小=v点丅.z;
                    if(v点丅.z>z大):z大=v点丅.z;

                x=abs(x大-x小); y=abs(y大-y小); z=abs(z大-z小);
                print("xyz==",x,y,z);
                if(x<y and x<z):#X轴最短
                    for bmv  in Lbmv选:
                        bmv.co.x=v最后选.x;

                elif(y<x and y<z):#Y轴最短
                    for bmv  in Lbmv选:
                        bmv.co.y=v最后选.y;

                elif(z<x and z<y):#Z轴最短
                    for bmv  in Lbmv选:
                        bmv.co.z=v最后选.z;

            else:
                for bmv  in Lbmv选:
                    if(self.bpX):
                        bmv.co.x=v最后选.x;
                    if(self.bpY):
                        bmv.co.y=v最后选.y;
                    if(self.bpZ):
                        bmv.co.z=v最后选.z;

        #------------------------------------------------------------
        id.update();
        #self.bm.free();#●●这个如果提前删除,如果继续编辑点会出错
        # ☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐━━━━━━━━━━━━☐☐☐☐☐☐☐☐☐☐
        #☐┃☐☐☐○━→●☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐┃☐☐/┇┄☐☐☐☐☐☐☐☐☐☐☐☐
        #☐┃☐/┄─☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐┃/─☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐●━━━━━━━━━━━ ☐☐ ☐☐ ☐☐ ☐☐ ☐☐
        # ☐头 ☐☐ ☐☐ ☐☐ ☐☐ ☐☐ ☐☐ ☐☐ ☐☐ ☐☐ ☐☐ ☐☐
        #bpy.ops.object.editmode_toggle();
        #bpy.ops.object.editmode_toggle();
        #for v in L序bmv选点:print("bmv==",L序bmv选点,len(L序bmv选点));
        return {"FINISHED"};
    pass;
#////////////////////////////////////////////
class 卐选择相似_相似uvCURVE卐Operator(bpy.types.Operator):
    bl_idname = "op.select_similar_uv"
    bl_label = "select faces of similar uv"
    bl_options = {"REGISTER", "UNDO"}

    fp选择阈值:FloatProperty(name='',description='',default=0.001,min=0.0,max=1.0,soft_min=0.0,soft_max=1.0,step=3,precision=2,update=None);

    #------------------------------------------------------------
    # @classmethod
    # def poll(cls, context):#决定是否激活
        # return (context.active_object.type in ["MESH"]);

    def draw(self, context):
        # if(context.active_object.type=="MESH"):
        row = self.layout.row();
        row.prop(self, "fp选择阈值");

    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self,width=400,height=50)

    def execute(self, context):
        oA=context.active_object;
        bpy.ops.mesh.select_mode(use_extend=False, use_expand=False, type="VERT", action="ENABLE");
        id=oA.data;Lmv=id.vertices;Lme=id.vertices;
        if (not  id.uv_layers.active):
            self.report({"ERROR"},"没有uv!!");#"INFO" "ERROR" "DEBUG"
            return {"FINISHED"};
        #----找到选择的uv---------------------------------------------------
        if(oA.mode!="OBJECT"):
            bpy.ops.object.mode_set(mode="OBJECT");
        Cmuvl = id.uv_layers.active.data ;Lmuvl顶点选=[];# 这个只能在物体模式下才能记录数据
        print("Cmuvl",Cmuvl);
        for ξ面,mp全部 in enumerate(id.polygons):
            i面点数=len(mp全部.loop_indices);
            for i步3 in range(i面点数):
                ξ点 = mp全部.vertices[i步3];
                i环=mp全部.loop_indices[i步3];
                if(id.vertices[ξ点].select):
                    Lmuvl顶点选.append(Cmuvl[i环]);

        #----选择uv相近顶点---------------------------------------------------
        for ξ面,mp全部 in enumerate(id.polygons):
            i面点数=len(mp全部.loop_indices);
            for i步3 in range(i面点数):
                ξ点 = mp全部.vertices[i步3];
                i环=mp全部.loop_indices[i步3];
                for muvl in Lmuvl顶点选:
                    if(abs(muvl.uv.x)<abs(Cmuvl[i环].uv.x)+self.fp选择阈值 and abs(Cmuvl[i环].uv.x)-self.fp选择阈值<abs(muvl.uv.x) and abs(muvl.uv.y)<abs(Cmuvl[i环].uv.y)+self.fp选择阈值 and abs(Cmuvl[i环].uv.y)-self.fp选择阈值<abs(muvl.uv.y)):
                        if(Lmv[ξ点].select==False and Lmv[ξ点].hide==False):
                            Lmv[ξ点].select=True;
                        break;
        
        #------------------------------------------------------------
        bpy.ops.object.editmode_toggle();
        return {"FINISHED"};
    pass;
    
#////////////////////////////////////////////
class 卐矩形化选点卐Operator(bpy.types.Operator):
    bl_idname = "bp.rect_selected"
    bl_label =语.L矩形[0];
    bl_description=语.L矩形[1];
    bl_options = {"REGISTER", "UNDO"}

    fp垂直偏差: FloatProperty(name=语.fp垂直偏差[0], description=语.fp垂直偏差[1],default=0.1,min=0.0, max=0.1, step=5, precision=3,) # soft_min=0.0001, soft_max=0.01,

    @classmethod
    def poll(cls, context):#决定是否激活
        o选=context.object
        if (o选!=None and (o选.type=="MESH" or o选.type=="CURVE")and (context.mode=="EDIT_MESH" or context.mode=="EDIT_CURVE" ) ):
            return True;
        return False;

    # def draw(self, context):#第貮步
        # layout = self.layout;
        #layout.prop(self, "bp旋转归零");
        # layout.prop(self, "fp垂直偏差", emboss=True,slider=True);
        """
        uil行=layout.row(align=True);
        uil行.prop(self, "bp拉直");
        uil行.prop(self, "bp自动对齐");
        layout.prop(self, "bp对齐到最后选点");
        uil行=layout.row(align=True);
        #if(not self.bp自动对齐):
        uil行.prop(self, "bpX");uil行.prop(self, "bpY");uil行.prop(self, "bpZ");
        """
    #def invoke(self, context, event):#召唤 第1步
        #return context.window_manager.invoke_props_dialog(self,width=400,height=50);

        #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐☐☐┄●━━━━━━━┄●☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐┄─☐☐☐☐☐☐☐┄─☐┃☐☐☐☐☐☐
        #☐☐☐☐☐☐☐●━━━━━━━━●☐☐☐┃☐☐☐☐☐☐
        #☐☐☐☐☐☐/☐☐☐☐☐☐☐☐/┃☐☐☐┃☐☐☐☐☐☐
        #☐☐☐☐☐/☐☐☐☐☐☐☐☐/☐┃☐☐☐┃☐☐☐☐☐☐
        #☐☐☐☐●━━━━━━━━●☐☐┃☐☐☐┃☐☐☐☐☐☐
        #☐☐☐┆┃┅┈☐☐☐☐┄└┃☐☐┃☐☐☐┃☐☐☐☐
        #☐☐☐│┃☐☐┅┈┄─☐☐┃☐☐┃☐☐☐┃☐☐☐☐
        #☐☐┆☐┃☐☐┄─┅┈☐☐┃☐☐┃☐☐☐┃☐☐☐☐☐
        #☐☐│☐┃┄─☐☐☐☐┅┈┃☐☐┃☐☐☐┃☐☐☐☐☐
        #☐┆☐☐○━━━━━━━━●☐☐┃☐☐┄●☐☐☐☐☐☐
        #☐●☐☐☐┅┈☐☐☐☐☐☐☐┅┈┃┄─☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐☐●━━━━━━━━●☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐


    def execute(self, context): #第三步
        if(G.dllMESHTL==None):
            G.dllMESHTL=dll载入dll(G,"dllMESHTL",dllpathMESHB,dllpathMESH,None);LG.dllIMDJS=G.dllMESHTL;
        oA=context.active_object;
        cvpOA = c_void_p(oA.as_pointer());cvpC= c_void_p(context.as_pointer());
        if(oA.mode!="OBJECT"):
            bpy.ops.object.mode_set(mode="OBJECT");
        G.dllMESHTL.Δ矩形(cvpC,cvpOA,c_float(self.fp垂直偏差));
        bpy.ops.object.editmode_toggle();
        oA.data.update();
        return {"FINISHED"};

    pass;
    
#///////////////////////////////////////////
class 卐轴到所选卐Operator(bpy.types.Operator):
    bl_idname = "bp.axis_to_selected"
    bl_label = 语.L轴到所选[0]
    bl_options = {"REGISTER", "UNDO"}
    bp旋转归零: BoolProperty(name="clear Rot", description="(clear rotation)旋转归零",default=False,update=ΔUPDATE选择 )
    # bp位置归零: BoolProperty(name="clear Loc", description="(clear location)位置归零",default=False,update=ΔUPDATE选择);
    bp丄: BoolProperty(name="normal direction",description="(normal direction)丄方向",default=False,update=ΔUPDATE选择 );

    @classmethod
    def poll(cls, context):#决定是否激活
        o选=context.object
        if (o选!=None and (o选.type=="MESH" or o选.type=="CURVE")and (context.mode=="EDIT_MESH" or context.mode=="EDIT_CURVE" ) ):
            return True;
        return False;

    # def draw(self, context):#第貮步
        # layout = self.layout;
        # layout.prop(self, "bp旋转归零");
        # layout.prop(self, "bp丄");

    def invoke(self, context, event):#召唤 第1步
        return context.window_manager.invoke_props_dialog(self,width=400,height=50);

    def execute(self, context): #第三步
        if(G.dllMESHTL==None):
            G.dllMESHTL=dll载入dll(G,"dllMESHTL",dllpathMESHB,dllpathMESH,None);
        oA=context.active_object;
        if(oA.mode!="OBJECT"):
            bpy.ops.object.mode_set(mode="OBJECT");
        cvpOA = c_void_p(oA.as_pointer());cvpC= c_void_p(context.as_pointer());
        CF3dimensionsA=(c_float*3)(*oA.dimensions);
        G.dllMESHTL.Δ轴到所选(cvpOA,CF3dimensionsA,self.bp丄,self.bp旋转归零);

        bpy.ops.object.editmode_toggle();
        oA.data.update();
        return {"FINISHED"};
    pass;
    
#==============================
class 卐关于我mesh_tools卐Operator(bpy.types.Operator):
    bl_idname = 'op.about_me_mesh_tools'
    bl_label = ''
    bl_description = 'about me'
    
    bp查看更新:BoolProperty(name="check for update of MeshTools?",description = 'check for update?',default=True);
    bp查看其它插件:BoolProperty(name='check my other addons?',description='check my other addons?',default=True,subtype='NONE',update=None);
    bp查看其它商业插件:BoolProperty(name='check my other addons?',description='check my other addons?',default=True,subtype='NONE',update=None);
    #------------------------------
    bp商业插件HairMesher:BoolProperty(name='HairMesher',description='HairMesher',default=True,subtype='NONE',update=None);
    bp商业插件DrawMesher:BoolProperty(name='DrawMesher',description='DrawMesher',default=True,subtype='NONE',update=None);
    本插件链接="https://gum.co/uuUht";
    url其它插件="https://blenderartists.org/u/imdjs/activity/topics";
    url其它商业插件HairMesher="https://gum.co/eHMMI";
    url其它商业插件DrawMesher="https://gum.co/DGytN";
    #------------------------------------------------------------
    @classmethod 
    def poll(self,context):
        return True ;
    
    def draw(self, context):
        for s in 语.Ls介绍:
            self.layout.label(text=s, text_ctxt="", translate=True, icon='NONE', icon_value=0);
            
        uil行=self.layout.row(align=False);
        uil行.prop(self, "bp查看更新");  
        self.layout.prop(self, "bp查看其它插件");  
        if(self.bp查看其它插件):
            uil行=self.layout.row(align=False);
            uil行.prop(self, "bp商业插件HairMesher",toggle=True);
            uil行.prop(self, "bp商业插件DrawMesher",toggle=True);

    def invoke(self, context, event):#运行的第1步
        return context.window_manager.invoke_props_dialog(self,width=600,height=50);

    def execute(self, context):
        # super.execute(context);
        if(self.bp查看更新):
            webbrowser.open(self.本插件链接, new=2, autoraise=True);
        if(self.bp查看其它插件):
            webbrowser.open(self.url其它插件, new=2, autoraise=True);
        if(self.bp查看其它商业插件):
            if(self.bp商业插件HairMesher):
                webbrowser.open(self.url其它商业插件HairMesher, new=2, autoraise=True);
            if(self.bp商业插件DrawMesher):
                webbrowser.open(self.url其它商业插件DrawMesher, new=2, autoraise=True);
        return {'FINISHED'};
    pass
#///end////end////end////end////end////end////end////end////end////










